Subject: Re: [6lo] 6lo Digest, Vol 24, Issue 11

From: Martin Turon <[email-masked]>
Date: Tue, 21 Apr 2015 08:14:05 -0700

Hi All,

To further the thoughts on a new "SWITCH" code as Robert suggests, I would
urge that any such code that effectively switches to a new 6lo parser also
have good versioning information for the protocol it is switching the
dispatch parser over to.  I'd also suggest that "ver. 0" of the SWITCH code
be reserved for switching the parser back into good'ol rfc6282 6lo:

0b01001xxx: SWITCH: Switch to secondary dispatch code page

  where: xxx = ver = 6lo dispatch version (set parser to this mode)

  ver = 0: parse subsequent dispatch codes as rfc6282 6lo

  ver = 1: "RPL-enhanced 6lo"

  ver > 1: hopefully defined by our children or our children's children

  ver = 7: breakout, subsequent byte contains version.

For ver != 7, the subsequent byte is a dispatch to be interpreted by the
given version of the parser.

I'm not necessarily pitching a SWITCH-based solution for RPL-enhanced 6lo;
I'm just providing some design suggestions if a SWITCH solution is pursued.

Martin

_____________________________
Martin Turon  |  Nest Labs

---------- Forwarded message ----------
> From: Robert Cragie <[email-masked]>
> To: Carsten Bormann <[email-masked]>, James Woodyatt <[email-masked]>,
> "Pascal Thubert (pthubert)" <[email-masked]>
> Cc: "[email-masked]" <
> [email-masked]>, "[email-masked]" <
> [email-masked]>
> Date: Tue, 21 Apr 2015 09:44:11 +0100
> Subject: Re: [6lo] (no subject)
>  Hi Carsten,
>
> I accept it was probably confusing to use "ESC" as that is an actual code
> point and the intent is to refer to an escape mechanism. I agree we don't
> have to use ESC (0b01000000) and we should probably leave ESC alone and
> keep it for the implied case where it really does have to be used before
> every alternative dispatch code. This also renders it virtually useless in
> practice as Pascal points out.
>
> So, considering using one of the reserved codes; the principle is similar
> to ESC but the suggestion is that it is more like a SWITCH. We could do the
> following:
>
> 0b01001xxx: SWITCH: Switch to secondary dispatch code page
>
> This would give 7 secondary dispatch code pages. We could reserve 6LoRH as
> page 0.
>
> Again, I stress we are trying to converge on a solution. If ESC or SWITCH
> (or whatever you want to call it) is not liked, we can drop it.
>
> Further comments inline.
>
> Robert
>

---

From: Robert Cragie <[email-masked]>
Date: Tue, 21 Apr 2015 18:41:55 +0100

Hi Martin,

Works for me. SWITCHing back during the parsing does provide extra 
flexibility so I think ver = 0 is a good idea. We could use ver = 7 for 
breakout but I guess there are other existing reserved dispatch codes 
still spare as well.

I too am not necessarily advocating this approach either but it is 
useful to explore and understand it.

Robert

On 21/04/2015 16:14, Martin Turon wrote:
>
> Hi All,
>
> To further the thoughts on a new "SWITCH" code as Robert suggests, I 
> would urge that any such code that effectively switches to a new 6lo 
> parser also have good versioning information for the protocol it is 
> switching the dispatch parser over to.  I'd also suggest that "ver. 0" 
> of the SWITCH code be reserved for switching the parser back into 
> good'ol rfc6282 6lo:
>
>     For ver != 7, the subsequent byte is a dispatch to be interpreted
>     by the given version of the parser.
>
> I'm not necessarily pitching a SWITCH-based solution for RPL-enhanced 
> 6lo; I'm just providing some design suggestions if a SWITCH solution 
> is pursued.
>
> Martin
>
>     From: Robert Cragie <[email-masked]
>     <mailto:[email-masked]>>
>     To: Carsten Bormann <[email-masked] <mailto:[email-masked]>>, James
>     Woodyatt <[email-masked] <mailto:[email-masked]>>, "Pascal
>     Thubert (pthubert)" <[email-masked] <mailto:[email-masked]>>
>     Cc: "[email-masked]
>     <mailto:[email-masked]>"
>     <[email-masked]
>     <mailto:[email-masked]>>,
>     "[email-masked] <mailto:[email-masked]>" <[email-masked]
>     <mailto:[email-masked]>>
>     I accept it was probably confusing to use "ESC" as that is an
>     actual code point and the intent is to refer to an escape
>     mechanism. I agree we don't have to use ESC (0b01000000) and we
>     should probably leave ESC alone and keep it for the implied case
>     where it really does have to be used before every alternative
>     dispatch code. This also renders it virtually useless in practice
>     as Pascal points out.
>
>     So, considering using one of the reserved codes; the principle is
>     similar to ESC but the suggestion is that it is more like a
>     SWITCH. We could do the following:
>
>     This would give 7 secondary dispatch code pages. We could reserve
>     6LoRH as page 0.
>
>     Again, I stress we are trying to converge on a solution. If ESC or
>     SWITCH (or whatever you want to call it) is not liked, we can drop it.
>
>     Further comments inline.
>
>     Robert
>
>
>
> _______________________________________________
> 6lo mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/6lo